#!/bin/bash

#Mithat Konar - 22 July 2008

# GUI wizard wrapper for Debian's adduser. Optionally adds user to
# "additional groups" and/or plugdev and/or makes user a superuser.

# ==========
# UI strings
# ==========
uiXdialogNotFound="Xdialog was not found.
Please install Xdialog to use this script."

uiAddUser="Add new user"
uiOk="Ok"
uiCancel="Cancel"
uiConfirmDetails="Confirm user details"
uiPressKey2Exit="Press ENTER to continue . . ."

uiNameRules=\
"Usernames may contain only lower-case letters, numbers, or\n\
the underscore character. They must start with a lower-case letter.\n\
\n\
Spaces, dashes, upper-case letters, etc. are not permitted."

uiEnterNewName="Enter new username:"
uiNoBlankNames="The username cannot be blank."
uiInvalidName="\"%s\" is not a valid username."
uiUserAlreadyExists="The user \"%s\" already exists on this system."

uiSetOptionsInfo=\
"Set the options below to determine what the new user can do."
uiSetOptionsHelp=\
"[ ] Allow user to change audio settings ...\n\
     Adds the new user to the 'extra groups' listed in the file \"adduser.conf\"\n\
     using adduser's --add_extra_groups flag. For more information consult\n\
     the man pages for the 'adduser' command. Also adds the user to the \n\
     'netdev' group.\n\
\n\
[ ] Allow user to automatically mount ...
     Adds the user to the 'plugdev' group, which enables automounting\n\
     of removable media for this user. For more information, consult\n\
     the man pages for 'pmount' and 'ivman'.\n\
\n\
[ ] Make user an administrator
     Adds the user to the list of superusers. Superusers are allowed to\n\
     add and remove software and make system-wide configuration changes.\n\
     Superusers are set in the \"/etc/sudoers\" file."

uiSetOptionsExtraDesc="Allow user to change audio settings, write to optical media, and do similar tasks."
uiSetOptionsPlugdevDesc="Allow user to automatically mount and unmount removable media."
uiSetOptionsSuperUserDesc="Make user an administrator."

uiConfirmUsername="The next step will create a new user called \"%s\" who is"
uiExtraGroupsYes="able to change audio settings, write to optical media, and do similar tasks"
uiExtraGroupsNo="un$uiExtraGroupsYes"
uiPlugdevYes="able to mount/unmount removable media"
uiPlugdevNo="un$uiPlugdevYes"
uiSuperUserYes="an administrator"
uiSuperUserNo="not $uiSuperUserYes"

uiLastChanceToCancel="Click \"Next\" to create this user."

uiTheEndMessage="The user \"%s\" has been added to the system."

# =======
# Globals
# =======
APPDIR=`dirname "$0"`
cd -P "$APPDIR"
APPDIR="`pwd`"

usersIcon="${APPDIR}/icons/users.xpm"
warningIcon="${APPDIR}/icons/warning.xpm"
errorIcon="${APPDIR}/icons/error.xpm"
tmpFile=/tmp/newuser.tmp.$$

dHeight=0		# height of dialog boxes (0 sets autosize)
dWidth=0		# width of dialog boxes (0 sets autosize)

# ======
# "Main"
# ======

# Test for Xdialog
isXdialog=`which Xdialog`
if [ -z $isXdialog ] ; then
	echo "$uiXdialogNotFound"
	xmessage -center -buttons Ok "$uiXdialogNotFound"
	exit 1
fi

	pw=`Xdialog --icon "$usersIcon" \
			--left \
			--wrap \
			--title "$uiAddUser" \
			--inputbox "One last time:\nEnter the new user's password:" $dHeight $dWidth "$gNewUsername"`
	
	echo "DEBUG: pw = $pw"
	
	# get pw again from and force a sudo action from the new user
	#echo $pw | sudo -u $newname -S -b sudo whoami 2> "$tmpFile"
	#rv=$?
